diff --git a/game/client/.gitignore b/game/client/.gitignore
index 4f654f768..cc46de012 100644
--- a/game/client/.gitignore
+++ b/game/client/.gitignore
@@ -1,3 +1,3 @@
 build
-dumpTextures
+/dumpTextures/
 logs
\ No newline at end of file
diff --git a/game/client/src/main/java/net/betterthanadventure/utils/DataDumper.java b/game/client/src/main/java/net/betterthanadventure/utils/DataDumper.java
index 32c65adac..9123e41e6 100644
--- a/game/client/src/main/java/net/betterthanadventure/utils/DataDumper.java
+++ b/game/client/src/main/java/net/betterthanadventure/utils/DataDumper.java
@@ -118,8 +118,8 @@ public class DataDumper implements MinecraftAccessor {
                 .append(item.getMaxDamage()).append(",")
                 .append(item instanceof ItemFood ? ((ItemFood) item).getHealAmount() : "").append(",")
                 .append(item.getItemStackLimit(null)).append(",")
-                .append("\"").append(translator.translateNameKey(item.getKey())).append("\"").append(",")
-                .append("\"").append(translator.translateDescKey(item.getKey())).append("\"").append(",");
+                .append("\"").append(translator.translateKey(item.getKey() + ".name")).append("\"").append(",")
+                .append("\"").append(translator.translateKey(item.getKey() + ".desc")).append("\"").append(",");
         builder.append("\"").append(taglistString(ItemTags.TAG_LIST, item)).append("\"");
         builder.append("\n");
         return builder.toString();
@@ -134,8 +134,8 @@ public class DataDumper implements MinecraftAccessor {
                 .append(block.getBlastResistance(null)).append(",")
                 .append(ItemToolPickaxe.miningLevels.getOrDefault(block, 0)).append(",")
                 .append(block.asItem().getItemStackLimit(null)).append(",")
-                .append("\"").append(translator.translateNameKey(block.getKey())).append("\"").append(",")
-                .append("\"").append(translator.translateDescKey(block.getKey())).append("\"").append(",");
+                .append("\"").append(translator.translateKey(block.getKey() + ".name")).append("\"").append(",")
+                .append("\"").append(translator.translateKey(block.getKey() + ".desc")).append("\"").append(",");
         builder.append("\"").append(taglistString(BlockTags.TAG_LIST, block)).append("\"");
         builder.append("\n");
         return builder.toString();
@@ -155,7 +155,7 @@ public class DataDumper implements MinecraftAccessor {
 
         StringBuilder weatherString = new StringBuilder();
         for (Weather weather : biome.blockedWeathers){
-            weatherString.append(weather.languageKey).append(", ");
+            weatherString.append(weather.getLanguageKey()).append(", ");
         }
         String s = weatherString.toString().trim();
         if (!s.isEmpty()){
diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index 13500a906..967c41a63 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -29,6 +29,7 @@ import net.minecraft.client.gui.options.data.OptionsPages;
 import net.minecraft.client.gui.toasts.GuiElementToastsHud;
 import net.minecraft.client.holiday.Holidays;
 import net.minecraft.client.net.handler.PacketHandlerClient;
+import net.minecraft.client.render.block.model.BlockModelGrass;
 import net.minecraft.client.world.WorldClient;
 import net.minecraft.client.world.chunk.provider.ChunkProviderStatic;
 import net.minecraft.core.achievement.Achievements;
@@ -113,7 +114,6 @@ import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.LoadingScreenRenderer;
 import net.minecraft.client.render.OpenGLHelper;
 import net.minecraft.client.render.PostProcessingManager;
-import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.RenderGlobal;
 import net.minecraft.client.render.Renderer;
@@ -280,10 +280,35 @@ public class Minecraft
     private boolean gameStarted = false;
     private int mojrand = new Random(System.currentTimeMillis()).nextInt(200);
     public TerrainRenderer terrainRenderer;
-    
-    public Minecraft(GameWindow gameWindow)
+
+    /**
+     * Keep this as the only constructor in this class for now,
+     * otherwise JVM class verification will fail and the game will crash when the fabric loader tries to run the game.
+     */
+    public Minecraft(GameWindow gameWindow, boolean test)
     {
-        this();
+        Global.accessor = this;
+        hasCrashed = false;
+        timer = new Timer(Global.TICKS_PER_SECOND);
+        session = null;
+        hideQuitButton = false;
+        isGamePaused = false;
+        currentScreen = null;
+        ticksRan = 0;
+        skipRenderWorld = false;
+        objectMouseOver = null;
+        running = true;
+        debug = "";
+        isTakingScreenshot = false;
+        inGameHasFocus = false;
+        mouseTicksRan = 0;
+        isRaining = false;
+        systemTime = System.currentTimeMillis();
+        joinPlayerCounter = 0;
+        INSTANCE = this;
+
+        if(test) return;
+
         this.gameWindow = gameWindow;
         this.resolution = new ScaledResolution(this.gameWindow);
 
@@ -310,27 +335,6 @@ public class Minecraft
             }
         };
     }
-    public Minecraft() {
-        Global.accessor = this;
-        hasCrashed = false;
-        timer = new Timer(Global.TICKS_PER_SECOND);
-        session = null;
-        hideQuitButton = false;
-        isGamePaused = false;
-        currentScreen = null;
-        ticksRan = 0;
-        skipRenderWorld = false;
-        objectMouseOver = null;
-        running = true;
-        debug = "";
-        isTakingScreenshot = false;
-        inGameHasFocus = false;
-        mouseTicksRan = 0;
-        isRaining = false;
-        systemTime = System.currentTimeMillis();
-        joinPlayerCounter = 0;
-        INSTANCE = this;
-    }
 
     public static boolean isClientASteamDeck() {
         final File vendor = new File("/sys/devices/virtual/dmi/id/board_vendor");
@@ -1035,7 +1039,7 @@ public class Minecraft
                     Debug.push("misc");		// 2
 
                     OpenGLHelper.checkError("pre render");
-                    RenderBlocks.fancyGrass = gameSettings.fancyGraphics.value == 1;
+                    BlockModelGrass.fancyGrass = gameSettings.fancyGraphics.value == 1;
                     EntityItem.enableItemClumping = gameSettings.enableItemClumping.value;
                     BlockLogicLeavesBase.enableTreeShadowing = gameSettings.treeShadows.value;
                     sndManager.updateListener(thePlayer, timer.partialTicks);
@@ -2623,7 +2627,7 @@ public class Minecraft
     public static void startMainThread(@Nullable String username, @Nullable String sessionId, @Nullable String uuid, @Nullable String server, @Nullable Integer port, @Nullable Integer width, @Nullable Integer height)
     {
         GameWindow gameWindow = new GameWindowGLFW();
-        Minecraft mc = new Minecraft(gameWindow);
+        Minecraft mc = new Minecraft(gameWindow,false);
         mc.minecraftUri = "www.minecraft.net";
 
         sessionId = sessionId == null ? "" : sessionId;
diff --git a/game/client/src/main/java/net/minecraft/client/console/shell/commands/fields.java b/game/client/src/main/java/net/minecraft/client/console/shell/commands/fields.java
index 0f76393c2..d15a62a93 100644
--- a/game/client/src/main/java/net/minecraft/client/console/shell/commands/fields.java
+++ b/game/client/src/main/java/net/minecraft/client/console/shell/commands/fields.java
@@ -12,6 +12,9 @@ import java.lang.reflect.Modifier;
 
 public class fields {
     public static RawOutputWrapper invoke(Interpreter env, CallStack callstack, Object o) {
+        if (o == null) {
+            return new RawOutputWrapper(TextFormatting.RED + "Argument was null!");
+        }
         final Class<?> clazz = o.getClass();
         StringBuilder sb = new StringBuilder();
         Field[] fields = clazz.getFields();
@@ -78,8 +81,8 @@ public class fields {
 
     private static void appendObject(Field field, Object o, StringBuilder sb) {
         try {
-            final @Nullable Object v = field.get(null);
-            if (o instanceof String) {
+            final @Nullable Object v = field.get(o);
+            if (v instanceof String) {
                 sb
                     .append(TextFormatting.LIGHT_BLUE)
                     .append("\"")
diff --git a/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleBlockBreaking.java b/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleBlockBreaking.java
index 4b6db2647..230b9486e 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleBlockBreaking.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleBlockBreaking.java
@@ -27,8 +27,9 @@ public class ParticleBlockBreaking extends Particle {
     public ParticleBlockBreaking init(int x, int y, int z) {
         int meta = this.world.getBlockMetadata(x, y, z);
         BlockModel<?> model = BlockModelDispatcher.getInstance().getDispatch(this.block);
-        if (model.shouldSideBeColored(this.world, x, y, z, this.side.getId(), meta)) {
-            int col = BlockColorDispatcher.getInstance().getDispatch(this.block).getWorldColor(this.world, x, y, z);
+        int index = model.particleColorIndex(this.world, x, y, z, this.side, meta);
+        if (index >= 0) {
+            int col = BlockColorDispatcher.getInstance().getDispatch(this.block).getWorldColor(this.world, x, y, z, index);
             this.rCol *= (col >> 16 & 0xff) / 255F;
             this.gCol *= (col >> 8 & 0xff) / 255F;
             this.bCol *= (col & 0xff) / 255F;
diff --git a/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java b/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
index 79b564dad..b5e5a9eb9 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
@@ -4,12 +4,10 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.util.dispatch.Dispatcher;
-import net.minecraft.core.Global;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.animal.MobFireflyCluster;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
-import net.minecraft.core.net.command.arguments.ArgumentTypeParticleId;
 import net.minecraft.core.util.helper.BlockParticleHelper;
 import net.minecraft.core.util.helper.MathHelper;
 
@@ -73,7 +71,7 @@ public final class ParticleDispatcher extends Dispatcher<String, ParticleLambda>
             return null;
         });
         addDispatch("dripWater", (world, x, y, z, motionX, motionY, motionZ, data) -> {
-            int color = BlockColorDispatcher.getInstance().getDispatch(Blocks.FLUID_WATER_STILL).getWorldColor(world, MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z));
+            int color = BlockColorDispatcher.getInstance().getDispatch(Blocks.FLUID_WATER_STILL).getWorldColor(world, MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z), 0);
             return new ParticleFluidDrip(world, x, y, z, color, TextureRegistry.getTexture("minecraft:block/water_flowing"));
         });
         addDispatch("dripLava", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleFluidDrip(world, x, y, z, 0xFFFFFF, TextureRegistry.getTexture("minecraft:block/lava_flowing")).setFullBright());
diff --git a/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleLeaf.java b/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleLeaf.java
index ed41e9f14..9a7cabea4 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleLeaf.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleLeaf.java
@@ -30,7 +30,7 @@ public class ParticleLeaf extends Particle {
     public ParticleLeaf init(int x, int y, int z) {
         Block<?> block = Blocks.blocksList[this.world.getBlockId(x, y, z)];
         if (!Block.hasLogicClass(block, BlockLogicLeavesBase.class)) this.remove();
-        int col = BlockColorDispatcher.getInstance().getDispatch(block).getWorldColor(world, x, y, z);
+        int col = BlockColorDispatcher.getInstance().getDispatch(block).getWorldColor(world, x, y, z, 0);
         this.rCol *= (float) (col >> 16 & 0xff) / 255F;
         this.gCol *= (float) (col >> 8 & 0xff) / 255F;
         this.bCol *= (float) (col & 0xff) / 255F;
diff --git a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
index a85d80004..a1d134c22 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
@@ -39,7 +39,6 @@ import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.vehicle.EntityBoat;
-import net.minecraft.core.entity.vehicle.MobGhastVehicle;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.client.net.command.ClientCommandSource;
@@ -70,7 +69,9 @@ public class PlayerLocal extends Player
         this.dimension = dimension;
         username = session.username;
         uuid = session.uuid;
-        
+
+        playerConfig.setLeftHand(minecraft.gameSettings.playerLeftHanded.value);
+
         new GetSkinUrlThread(this);
         LOGGER.info("logged in with session name: {}", username);
     }
@@ -263,15 +264,15 @@ public class PlayerLocal extends Player
     }
 
     @Override
-    public void displaySignEditorScreen(TileEntitySign blockEntity)
+    public void displaySignEditorScreen(TileEntitySign tileEntity)
     {
-        mc.displayScreen(new ScreenSignEditor(blockEntity));
+        mc.displayScreen(new ScreenSignEditor(tileEntity));
     }
 
     @Override
-    public void displayFlagEditorScreen(TileEntityFlag blockEntity)
+    public void displayFlagEditorScreen(TileEntityFlag tileEntity)
     {
-        mc.displayScreen(new ScreenFlagEditor(this, blockEntity));
+        mc.displayScreen(new ScreenFlagEditor(this, tileEntity));
     }
 
     @Override
@@ -300,7 +301,7 @@ public class PlayerLocal extends Player
 
     @Override
     public void displayMobPickerScreen(int x, int y, int z) {
-        String currentMobId = ((TileEntityMobSpawner) world.getBlockEntity(x, y, z)).getMobId();
+        String currentMobId = ((TileEntityMobSpawner) world.getTileEntity(x, y, z)).getMobId();
         mc.displayScreen(new ScreenMobPicker(currentMobId, x, y, z));
     }
     @Override
@@ -310,27 +311,27 @@ public class PlayerLocal extends Player
     }
 
     @Override
-    public void displayFurnaceScreen(TileEntityFurnace blockEntity)
+    public void displayFurnaceScreen(TileEntityFurnace tileEntity)
     {
-        mc.displayScreen(new ScreenFurnace(inventory, blockEntity));
+        mc.displayScreen(new ScreenFurnace(inventory, tileEntity));
     }
 
     @Override
-    public void displayTrommelScreen(TileEntityTrommel blockEntity)
+    public void displayTrommelScreen(TileEntityTrommel tileEntity)
     {
-        mc.displayScreen(new ScreenTrommel(inventory, blockEntity));
+        mc.displayScreen(new ScreenTrommel(inventory, tileEntity));
     }
 
     @Override
-    public void displayDispenserScreen(TileEntityDispenser blockEntity)
+    public void displayDispenserScreen(TileEntityDispenser tileEntity)
     {
-        mc.displayScreen(new ScreenDispenser(inventory, blockEntity));
+        mc.displayScreen(new ScreenDispenser(inventory, tileEntity));
     }
 
     @Override
-    public void displayActivatorScreen(TileEntityActivator blockEntity)
+    public void displayActivatorScreen(TileEntityActivator tileEntity)
     {
-        mc.displayScreen(new ScreenActivator(inventory, blockEntity));
+        mc.displayScreen(new ScreenActivator(inventory, tileEntity));
     }
 
     @Override
@@ -532,8 +533,5 @@ public class PlayerLocal extends Player
         if (vehicle instanceof EntityBoat) {
             ((EntityBoat) vehicle).controlBoat(-input.moveForward, -input.moveStrafe);
         }
-        if (vehicle instanceof MobGhastVehicle) {
-            ((MobGhastVehicle) vehicle).controlVehicle(-input.moveForward, -input.moveStrafe, input.jump, input.sneak);
-        }
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
index 765a860fc..1f68a30b4 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
@@ -7,9 +7,12 @@ import net.minecraft.core.achievement.stat.Stat;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.net.packet.PacketBoatControl;
 import net.minecraft.core.net.packet.PacketChat;
+import net.minecraft.core.net.packet.PacketContainerSetSlot;
+import net.minecraft.core.net.packet.PacketPlayerConfig;
 import net.minecraft.core.net.packet.PacketUpdatePlayerState;
 import net.minecraft.core.net.packet.PacketMovePlayer;
 import net.minecraft.core.net.packet.PacketContainerClose;
@@ -26,7 +29,7 @@ import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-public class PlayerLocalMultiplayer extends PlayerLocal
+public class PlayerLocalMultiplayer extends PlayerLocal implements Player.PlayerConfig.PlayerConfigListener
 {
     public PacketHandlerClient sendQueue;
     private int lastInventorySendTime;
@@ -50,6 +53,7 @@ public class PlayerLocalMultiplayer extends PlayerLocal
         wasSneaking = false;
         noSendTime = 0;
         sendQueue = netclienthandler;
+        playerConfig.assignListener(this);
     }
 
     @Override
@@ -283,4 +287,9 @@ public class PlayerLocalMultiplayer extends PlayerLocal
             sendQueue.addToSendQueue(new PacketBoatControl((EntityBoat) vehicle));
         }
     }
+
+    @Override
+    public void onValueChange() {
+        sendQueue.addToSendQueue(new PacketPlayerConfig(playerConfig));
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ItemElement.java b/game/client/src/main/java/net/minecraft/client/gui/ItemElement.java
index 89fdd2116..1a4f46e74 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ItemElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ItemElement.java
@@ -1,9 +1,7 @@
 package net.minecraft.client.gui;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.EntityRenderDispatcher;
 import net.minecraft.client.render.Lighting;
-import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.item.model.ItemModel;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
@@ -66,9 +64,8 @@ public class ItemElement extends Gui
         {
             GL11.glEnable(GL11.GL_DEPTH_TEST);
             if (itemStack != null){
-                BlockModel.setRenderBlocks(EntityRenderDispatcher.instance.itemRenderer.renderBlocksInstance);
                 ItemModel itemModel = ItemModelDispatcher.getInstance().getDispatch(itemStack.getItem());
-                itemModel.renderItemIntoGui(Tessellator.instance, mc.font, mc.textureManager, itemStack, x, y, discovered ? 1.0f : 0.0f, 1.0f);
+                itemModel.renderGui(Tessellator.instance, null, itemStack, x, y, discovered ? 1.0f : 0.0f, 1.0f, 1f);
                 if(slot instanceof SlotGuidebook){
                     if(((SlotGuidebook) slot).recipe instanceof RecipeEntryTrommel && ((SlotGuidebook) slot).item != null && ((SlotGuidebook) slot).isOutput){
                         WeightedRandomBag<WeightedRandomLootObject> loot = ((RecipeEntryTrommel)((SlotGuidebook) slot).recipe).getOutput();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/Screen.java b/game/client/src/main/java/net/minecraft/client/gui/Screen.java
index 02e9df1ab..8176b3eb0 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/Screen.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/Screen.java
@@ -146,7 +146,7 @@ public abstract class Screen extends Gui {
                     mc.gameWindow.toggleFullscreen();
                     return;
                 }
-                if (!(this instanceof ScreenConsole) && eventKey == mc.gameSettings.keyShowConsole.getKeyCode()) {
+                if (!(this instanceof ScreenConsole) && eventKey == mc.gameSettings.keyShowConsole.getKeyCode() && mc.gameSettings.developerMode.value && !Keyboard.areRepeatEventsEnabled()) {
                     mc.displayScreen(new ScreenConsole(this));
                     return;
                 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenCreateWorld.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenCreateWorld.java
index 8cab41988..301594ee2 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenCreateWorld.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenCreateWorld.java
@@ -182,9 +182,9 @@ public class ScreenCreateWorld extends Screen {
 
     private void updateButtons() {
         I18n i18n = I18n.getInstance();
-        gamemodeButton.displayString = i18n.translateKeyAndFormat("gui.create_world.button.gamemode", i18n.translateNameKey(selectedGamemode.getLanguageKey()));
+        gamemodeButton.displayString = i18n.translateKeyAndFormat("gui.create_world.button.gamemode", i18n.translateKey(selectedGamemode.getLanguageKey() + ".name"));
         cheatsButton.displayString = i18n.translateKeyAndFormat("gui.create_world.button.cheats", i18n.translateKey(cheatsEnabled ? "gui.create_world.button.cheats.on" : "gui.create_world.button.cheats.off"));
-        worldTypeButton.displayString = i18n.translateKeyAndFormat("gui.create_world.button.world_type", i18n.translateNameKey(worldTypeGroup.get(Dimension.OVERWORLD).getLanguageKey()));
+        worldTypeButton.displayString = i18n.translateKeyAndFormat("gui.create_world.button.world_type", i18n.translateKey(worldTypeGroup.get(Dimension.OVERWORLD).getLanguageKey() + ".name"));
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
index 76abaefb3..46ca59dcc 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
@@ -19,6 +19,7 @@ import com.mojang.logging.LogUtils;
 import net.minecraft.client.gui.hud.HudIngame;
 import net.minecraft.client.gui.hud.HudIngameDoom;
 import net.minecraft.client.holiday.Holidays;
+import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
@@ -30,7 +31,6 @@ import org.lwjgl.util.glu.GLU;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.options.ScreenOptions;
 import net.minecraft.client.gui.options.data.OptionsPages;
-import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.lang.I18n;
@@ -410,6 +410,7 @@ public class ScreenMainMenu extends Screen
         GL11.glCullFace(GL11.GL_BACK);
         GL11.glDepthMask(true);
         GL11.glEnable(GL11.GL_DEPTH_TEST);
+        Lighting.enableLight();
         
         for(int var4 = 0; var4 < 3; ++var4) {
             GL11.glPushMatrix();
@@ -441,26 +442,24 @@ public class ScreenMainMenu extends Screen
                 this.mc.textureManager.loadTexture("/title/black.png").bind();
             }
 
-            RenderBlocks var5 = new RenderBlocks();
-
-            for(int var6 = 0; var6 < logoBlockLayers.length; ++var6) {
-                for(int var7 = 0; var7 < logoBlockLayers[var6].length(); ++var7) {
-                    char var8 = logoBlockLayers[var6].charAt(var7);
+            for(int y = 0; y < logoBlockLayers.length; ++y) {
+                for(int x = 0; x < logoBlockLayers[y].length(); ++x) {
+                    char var8 = logoBlockLayers[y].charAt(x);
                     if(var8 != ' ') {
                         GL11.glPushMatrix();
-                        LogoBlock var9 = this.logoBlocks[var7][var6];
-                        float var10 = (float)(var9.prevHeight + (var9.height - var9.prevHeight) * (double)var1);
-                        float var11 = 1.0F;
-                        float var12 = 1.0F;
+                        LogoBlock var9 = this.logoBlocks[x][y];
+                        float z = (float)(var9.prevHeight + (var9.height - var9.prevHeight) * (double)var1);
+                        float scale = 1.0F;
+                        float alpha = 1.0F;
                         if(var4 == 0) {
-                            var11 = var10 * 0.04F + 1.0F;
-                            var12 = 1.0F / var11;
-                            var10 = 0.0F;
+                            scale = z * 0.04F + 1.0F;
+                            alpha = 1.0F / scale;
+                            z = 0.0F;
                         }
 
-                        GL11.glTranslatef((float)var7, (float)var6, var10);
-                        GL11.glScalef(var11, var11, var11);
-                        var5.renderBlockAsItem(Tessellator.instance, BlockModelDispatcher.getInstance().getDispatch(BLOCKS_TO_DRAW[indexToDraw]), var12);
+                        GL11.glTranslatef(x, y, z);
+                        GL11.glScalef(scale, scale, scale);
+                        BlockModelDispatcher.getInstance().getDispatch(BLOCKS_TO_DRAW[indexToDraw]).renderStandalone(Tessellator.instance, 0, 1f, alpha, null);
                         GL11.glPopMatrix();
                     }
                 }
@@ -468,6 +467,7 @@ public class ScreenMainMenu extends Screen
 
             GL11.glPopMatrix();
         }
+        Lighting.disable();
 
         GL11.glDisable(GL11.GL_BLEND);
         GL11.glMatrixMode(GL11.GL_PROJECTION);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenMobPicker.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenMobPicker.java
index 323df04c2..9fbd5a4c3 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenMobPicker.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenMobPicker.java
@@ -62,7 +62,7 @@ public class ScreenMobPicker
                 if (statusCode == 1) {
                     mobId = monsters.get((Integer) results.get("list")).toString();
                     if (!mc.currentWorld.isClientSide) {
-                        TileEntityMobSpawner spawner = (TileEntityMobSpawner) mc.currentWorld.getBlockEntity(x, y, z);
+                        TileEntityMobSpawner spawner = (TileEntityMobSpawner) mc.currentWorld.getTileEntity(x, y, z);
                         if (spawner == null) {
                             return;
                         }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenSelectWorld.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenSelectWorld.java
index 02ca6352d..84bcd719c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenSelectWorld.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenSelectWorld.java
@@ -334,11 +334,11 @@ public class ScreenSelectWorld extends Screen
                 if (dd == null){
                     s2 += TextFormatting.RED + st.translateKey("gui.select_world.label.dimension_corrupted");
                 } else {
-                    s2 += st.translateNameKey(Gamemode.gamemodesList[ld.getGamemode()].getLanguageKey());
+                    s2 += st.translateKey(Gamemode.gamemodesList[ld.getGamemode()].getLanguageKey() + ".name");
                     if (ld.getCheatsEnabled()) s2 += " | " + st.translateKey("gui.select_world.label.cheats");
                     WorldType worldType = dd.getWorldType();
                     if (worldType != null) {
-                        s2 += " | " + st.translateNameKey(dd.getWorldType().getLanguageKey());
+                        s2 += " | " + st.translateKey(dd.getWorldType().getLanguageKey() + ".name");
                     } else {
                         s2 += " | " + TextFormatting.RED + st.translateKey("gui.select_world.label.unknown");
                     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
index 5f37c90d0..9a423b1d7 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
@@ -10,7 +10,7 @@ import net.minecraft.core.block.entity.TileEntitySign;
 import net.minecraft.core.enums.EnumSignPicture;
 import net.minecraft.core.util.helper.ChatAllowedCharacters;
 import net.minecraft.core.net.packet.PacketSignUpdate;
-import net.minecraft.client.render.BlockEntityRenderDispatcher;
+import net.minecraft.client.render.TileEntityRenderDispatcher;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.lang.I18n;
 import org.lwjgl.input.Keyboard;
@@ -186,7 +186,7 @@ public class ScreenSignEditor extends Screen
         {
             entitySign.lineBeingEdited = editLine;
         }
-        BlockEntityRenderDispatcher.instance.renderTileEntity(Tessellator.instance, entitySign, -0.5D, -0.75D, -0.5D, 0.0F);
+        TileEntityRenderDispatcher.instance.renderTileEntity(Tessellator.instance, entitySign, -0.5D, -0.75D, -0.5D, 0.0F);
         entitySign.lineBeingEdited = -1;
         GL11.glPopMatrix();
         
